/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.gui.widgets;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Locale;
import javax.swing.DefaultBoundedRangeModel;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.apache.log4j.Logger;
import org.visnow.vn.system.main.VisNow;
import org.jdesktop.swingx.JXPanel;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class TestFrame extends javax.swing.JFrame
{

    JLabel jLabel1 = new JLabel("overlay");
    private static final Logger LOGGER = Logger.getLogger(TestFrame.class);

    private JComponent createColoredBox()
    {

        JXPanel panel = new JXPanel();
        panel.setLayout(null);
        panel.setLayout(new GridLayout());
        panel.setBackground(new Color(1.f, .9f, .9f));
        panel.setAlpha(.8f);
        JLabel label = new JLabel("overlay");
        label.setForeground(new Color(.3f, 0f, 0f));
        panel.setForeground(Color.black);
        label.setBounds(0, 0, 100, 20);
        panel.setLayout(new java.awt.BorderLayout());
        panel.add(label, BorderLayout.CENTER);
        panel.setBounds(0, 0, 140, 140);
        panel.addMouseListener(new MouseListener()
        {
            @Override
            public void mouseClicked(MouseEvent e)
            {
                System.out.println("caught");
            }

            @Override
            public void mousePressed(MouseEvent e)
            {
                System.out.println("caught");
            }

            @Override
            public void mouseReleased(MouseEvent e)
            {
                System.out.println("caught");
            }

            @Override
            public void mouseEntered(MouseEvent e)
            {
                System.out.println("caught");
            }

            @Override
            public void mouseExited(MouseEvent e)
            {
                System.out.println("caught");
            }
        });
        return panel;
    }

    JComponent component = createColoredBox();

    public TestFrame()
    {
        initComponents();
        extendedIntRoller1.addChangeListener(new ChangeListener()
        {
            @Override
            public void stateChanged(ChangeEvent e)
            {
                System.out.println("" +extendedIntRoller1.getValue());
            }
        });

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        extendedIntRoller1 = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedIntRoller();
        jSlider1 = new RollSlider(new DefaultBoundedRangeModel());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(60, 50));
        getContentPane().add(extendedIntRoller1, java.awt.BorderLayout.NORTH);

        jSlider1.setMajorTickSpacing(20);
        jSlider1.setMinorTickSpacing(2);
        jSlider1.setPaintLabels(true);
        jSlider1.setPaintTicks(true);
        jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider1StateChanged(evt);
            }
        });
        getContentPane().add(jSlider1, java.awt.BorderLayout.SOUTH);

        setSize(new java.awt.Dimension(236, 122));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider1StateChanged
        System.out.println(""+jSlider1.getValue() + " "+jSlider1.getValueIsAdjusting());
    }//GEN-LAST:event_jSlider1StateChanged

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        VisNow.initLogging(true);
        Locale.setDefault(VisNow.LOCALE);

        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                new TestFrame().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedIntRoller extendedIntRoller1;
    private javax.swing.JSlider jSlider1;
    // End of variables declaration//GEN-END:variables
}
